package ctbrec.ui.sites.chaturbate;

import ctbrec.sites.chaturbate.Chaturbate;
import ctbrec.ui.sites.AbstractTabProvider;
import ctbrec.ui.tabs.PaginatedScheduledService;
import ctbrec.ui.tabs.ThumbOverviewTab;
import javafx.scene.Scene;
import javafx.scene.control.Tab;

import java.util.ArrayList;
import java.util.List;

public class ChaturbateTabProvider extends AbstractTabProvider {

    private ChaturbateFollowedTab followedTab;
    private Chaturbate site;
    private String API_URL;

    public ChaturbateTabProvider(Chaturbate chaturbate) {
        super(chaturbate);
        this.site = chaturbate;
        API_URL = site.getBaseUrl() + "/api/ts";
    }

    @Override
    protected List<Tab> getSiteTabs(Scene scene) {
        List<Tab> tabs = new ArrayList<>();
        tabs.add(createTab("All", API_URL + "/roomlist/room-list/?enable_recommendations=false"));
        tabs.add(createTab("Girls", API_URL + "/roomlist/room-list/?enable_recommendations=false&genders=f"));
        tabs.add(createTab("New Girls", API_URL + "/roomlist/room-list/?enable_recommendations=false&genders=f&new_cams=true"));
        tabs.add(createTab("Boys", API_URL + "/roomlist/room-list/?enable_recommendations=false&genders=m"));
        tabs.add(createTab("New Boys", API_URL + "/roomlist/room-list/?enable_recommendations=false&genders=m&new_cams=true"));
        tabs.add(createTab("Couples", API_URL + "/roomlist/room-list/?enable_recommendations=false&genders=c"));
        tabs.add(createTab("Trans", API_URL + "/roomlist/room-list/?enable_recommendations=false&genders=t"));
        tabs.add(createTab("Private", API_URL + "/roomlist/room-list/?enable_recommendations=false&private=true"));
        tabs.add(createTab("Hidden", API_URL + "/roomlist/room-list/?enable_recommendations=false&hidden=true"));
        followedTab = new ChaturbateFollowedTab("Followed", API_URL + "/roomlist/room-list/?enable_recommendations=false&follow=true&offline=false", site);
        followedTab.setScene(scene);
        followedTab.setRecorder(recorder);
        followedTab.setImageAspectRatio(9.0 / 16.0);
        tabs.add(followedTab);
        tabs.add(createApiTab("Top Rated", API_URL + "/discover/carousels/top-rated/"));
        tabs.add(createApiTab("Trending", API_URL + "/ts/discover/carousels/trending/"));
        tabs.add(createApiTab("Recommended", API_URL + "/discover/carousels/recommended/"));
        return tabs;
    }


    @Override
    public Tab getFollowedTab() {
        return followedTab;
    }

    private Tab createTab(String title, String url) {
        var updateService = new ChaturbateUpdateService(url, false, (Chaturbate) site);
        return createTab(title, updateService);
    }

    private Tab createTab(String title, PaginatedScheduledService updateService) {
        var tab = new ThumbOverviewTab(title, updateService, site);
        tab.setRecorder(recorder);
        tab.setImageAspectRatio(9.0 / 16.0);
        return tab;
    }

    private Tab createApiTab(String title, String apiUrl) {
        var updateService = new ChaturbateApiUpdateService(apiUrl, (Chaturbate) site);
        return createTab(title, updateService);
    }
}
